unit bi_btns;

interface

uses Windows, Messages, Classes, Controls, Forms, Graphics,
  ExtCtrls, buttons, bi_timer,menus;

  const crhand = 4001;
  
type
 TTextStyle = (tsNormal, tsRaised, tsLowered, tsShaddow);
 TAlignment = (taCenter, taLeftJustify, taRightJustify);
//<<Basebutton-----------------------------------------------------------------------
{*
  This is the base class for TBI_Button, TBI_GradientButton, TBI_PlasmaButton
  and TBI_ImageButton. Nearly everthing except of the specific painting is done here.
  It would have been easier to create one button that has a fill style property, but
  I decided to do it this way as it makes the later creation of new ancestors easier.
  Also, it makes a class available that can be used by you for own IE/Office 97 like
  buttons - consider the differnce being like TCustomMemo and TMemo.
*}
 TBI_basebutton = class(tgraphiccontrol)
  private
    fscolor              : tcolor;
    fecolor              : tcolor;
    fbevel               : integer;
    fenabled             : boolean;
    fflat                : boolean;
    fspacing             : integer;
    transclr             : tcolor;
    gwidth               : integer;
    fnumglyphs           : byte;
    drawframe            : boolean;
    fglyph               : tbitmap;
    lowcolor             : boolean;
    fpaint256            : boolean;
    fgray                : boolean;
    fpopupmark           : boolean;
    fdown                : boolean;
    fgroupindex          : integer;
    fallup               : boolean;
    fpopupmenu           : tpopupmenu;
    flayout              : tbuttonlayout;
    procedure setscolor(value: tcolor); virtual;
    procedure setecolor(value: tcolor); virtual;
    procedure setbevel(value: integer);
    procedure setspacing(value: integer);
    procedure setflat(value: boolean);
    procedure setgray(value: boolean);
    procedure setenabled(value: boolean);
    procedure setmark(value: boolean);
    procedure setlayout(value: tbuttonlayout);
    procedure setglyph(value: tbitmap);
    procedure Setpopup(value: TPopupMenu);
    procedure setdown(value: boolean);
    procedure setgroupindex(value:integer);
    procedure setallup(value:boolean);
    procedure internalpaint(var buffer:tbitmap);
    procedure loaded;override;
    procedure Getglyph(const no:byte;var c_glyph:tbitmap);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected
    FState: TButtonState;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override ;
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property LightColor:tcolor read fscolor write setscolor;
    property ShadowColor:tcolor read fecolor write setecolor;
    property Glyph:tbitmap read fglyph write setglyph;
    property DropDownMenu:tpopupmenu read fpopupmenu write setpopup;
    property GrayedInactive:boolean read fgray write setgray default false;
    property Caption;
    property Layout:tbuttonlayout read flayout write setlayout;
    property BevelWidth:integer read fbevel write setbevel default 1;
    property Font;
    property Down:boolean read fdown write setdown stored true default false;
    property GroupIndex:integer read fgroupindex write setgroupindex;
    property AllowAllUp:boolean read fallup write fallup stored true default false;
    property Enabled:boolean read fenabled write setenabled default true;
    property Flat:boolean read fflat write setflat default false;
    property MarkDropDown:boolean read fpopupmark write setmark default true;
    property Spacing:integer read fspacing write setspacing default 1;
    property Paint256:boolean read fpaint256 write fpaint256 default false;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property ShowHint;
    property ParentFont;

  end;

  TBI_TorryButton = class(tgraphiccontrol)
  private
    drawframe            : boolean;
    fscolor              : tcolor;
    fecolor              : tcolor;
    fdowncolor           : tcolor;
    falign               : talignment;
    fdown                : boolean;
    fgroupindex          : integer;
    fallup               : boolean;
    foffset              : integer;
    fHfont               : tfont;
    procedure setscolor(value: tcolor);
    procedure setecolor(value: tcolor);
    procedure setalign(value: talignment);
    procedure setoffset(value: integer);
    procedure sethfont(value: Tfont);
    procedure setdown(value: boolean);
    procedure setgroupindex(value:integer);
    procedure setdowncolor(value:tcolor);
    procedure setallup(value:boolean);
    procedure loaded;override;
    procedure torrytextout(var buffer:tbitmap);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected
    FState: TButtonState;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor destroy;override;
  published
    property Color:tcolor read fscolor write setscolor;
    property ShadowColor:tcolor read fecolor write setecolor;
    property ShadowOffset:integer read foffset write setoffset;
    property HighlightFont:Tfont read fHfont write setHfont;
    property Down:boolean read fdown write setdown stored true default false;
    property GroupIndex:integer read fgroupindex write setgroupindex;
    property DownColor:tcolor read fdowncolor write setdowncolor;
    property AllowAllUp:boolean read fallup write fallup stored true default false;
    property Caption;
    property Font;
    property Alignment:talignment read falign write setalign;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property ShowHint;
    property ParentFont;
  end;

    ///////Normal (IE like)
    BI_Buttonstyle = (bisOpaque, bisTransparent, bisOwnerdraw);
    TDrawButtonEvent =
                     procedure(ButtonCanvas:Tcanvas; const Rect: TRect; var DrawFace:Boolean) of object;
    TBI_Button=class(TBI_basebutton)
    private
           fstyle:BI_Buttonstyle;
           fOnDraw:TDrawButtonEvent;
           procedure SetStyle(value:BI_Buttonstyle);
           procedure SetOnDraw(Value:TDrawButtonEvent);
    public
           constructor Create(AOwner: TComponent); override;
    protected
           procedure paint; override;
    published
           property Color;
           property Style:BI_Buttonstyle read fstyle write setstyle;
           property OnDraw:TDrawButtonEvent read fOnDraw write setondraw;
    end;
    {As you can see, it's easy to create own buttons based on TBI_Button using
    the owner draw style}
    ///////Gradient
    TBI_GradientButton=class(TBI_basebutton)
    private
           fvertical:boolean;
           procedure setvertical(value: boolean);
    public
           constructor Create(AOwner: TComponent); override;
    protected
           procedure paint; override;
    published
           property Vertical:boolean read fvertical write setvertical;
    end;
    //////// Plasma
    {I could have used the DIBSurface in order to prevent
     the distortion of the Plasma, but I actually like the
     effect although I discovered it by accident. For those
     interested: If the plasma array would not be distorted in
     the buffer, the image had a more cloud like appearance instead
     of a mineral look...}
    TBI_PlasmaButton=class(TBI_basebutton)
    private
           _colors:array[0..255] of tcolor;
           plasmabuffer:tbitmap;
           procedure createplasma;
           procedure setscolor(value: tcolor); override;
           procedure setecolor(value: tcolor); override;
    public
           constructor Create(AOwner: TComponent); override;
           destructor destroy; override;
           procedure recalc;
    protected
           procedure paint; override;
    published
    end;
        //////// Image
    TBI_ImageButton=class(TBI_basebutton)
    private
           fupimage:tbitmap;
           fdownimage:tbitmap;
           fMouseOverImage:tbitmap;
           drawMOI:boolean;
           fstretch:boolean;
           ftrans:boolean;
           ftransclr:tcolor;
           procedure setupimage(value: tbitmap);
           procedure setdownimage(value: tbitmap);
           procedure setMouseOverImage(value: tbitmap);
           procedure setstretch(value:boolean);
           procedure settrans(value:boolean);
           procedure settransclr(value:tcolor);
           procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
           procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    public
           constructor Create(AOwner: TComponent); override;
           destructor destroy; override;
    protected
           procedure paint; override;
           procedure checkothers;
    published
           property Stretch:boolean read fstretch write setstretch;
           property UpImage:tbitmap read fupimage write setupimage;
           property TransparentColor:tcolor read ftransclr write settransclr;
           property DownImage:tbitmap read fDownimage write setDownimage;
           property MouseOverImage:tbitmap read fMouseOverImage write setMouseOverImage;
           property Transparent:boolean read ftrans write settrans;
    end;

implementation

{$R bi_ctrls.res}
uses consts,bi_procs;

constructor TBI_basebutton.Create(AOwner: TComponent);
var    DCBitCount:integer;
begin
inherited Create(AOwner);

dcbitcount:=getcolorcaps;
if dcbitcount<16 then lowcolor:=true else lowcolor:=false;

ControlStyle := [csclickevents, csCaptureMouse, csOpaque, csDoubleClicks];
fpopupmenu:=nil;
width:=25;
height:=25;
fgroupindex:=0;
fdown:=false;
fallup:=false;
fscolor:=clbtnhighlight;
fecolor:=clbtnshadow;
fenabled:=true;
fbevel:=1;
fspacing:=1;
fnumglyphs:=0;
fflat:=false;
fpaint256:=false;
fpopupmark:=true;
flayout:=blglyphleft;
fgray:=true;
drawframe:=true;
fglyph:=tbitmap.create;
end;

destructor TBI_basebutton.destroy;
begin
fglyph.free;
inherited destroy;
end;

procedure TBI_basebutton.loaded;
begin
inherited loaded;
setglyph(fglyph);
end;

procedure TBI_basebutton.setlayout(value: tbuttonlayout);
begin
if value<>flayout then
   begin
   flayout:=value;
   invalidate;
   end;
end;

procedure TBI_basebutton.Setpopup(value: TPopupMenu);
begin
	fpopupmenu := value;
	if fpopupmark then
		invalidate;
end;

procedure TBI_basebutton.setscolor(value: tcolor);
begin
if value<>fscolor then
begin
fscolor:=value;
invalidate;
end;
end;

procedure TBI_basebutton.setenabled(value: boolean);
begin
if value<>fenabled then
begin
fenabled:=value;
invalidate;
end;
end;

procedure TBI_basebutton.setgray(value: boolean);
begin
if value<>fgray then
begin
fgray:=value;
invalidate;
end;
end;

procedure TBI_basebutton.setdown(value: boolean);
var i: Integer;
otherbutton: TBI_basebutton;
begin
	if FDown = value then
   	Exit;
	if FGroupIndex <> 0 then
	begin
          FDown := value;
          invalidate;
          if FDown = True then
          begin
                  for i := 0 to Parent.ControlCount - 1 do
                  begin
                          if Parent.Controls[i] is TBI_basebutton then
                          begin
                                  otherbutton := (Parent.Controls[i] as TBI_basebutton);
                                  if (otherbutton <> Self) and (otherbutton.GroupIndex = GroupIndex)
                                          and (otherbutton.FDown = True) then
                                  begin
                                          otherbutton.FDown := False;
                                          otherbutton.invalidate;
                                  end
                          end
                  end
          end
  end
end;

procedure TBI_basebutton.setallup(value:boolean);
var i: Integer;
otherbutton: TBI_basebutton;
begin
	FAllUp := value;
	if FGroupIndex <> 0 then
	begin
		for i := 0 to Parent.ControlCount - 1 do
		begin
			if Parent.Controls[i] is TBI_basebutton then
			begin
				otherbutton := (Parent.Controls[i] as TBI_basebutton);
				if (otherbutton <> Self) and (otherbutton.GroupIndex = GroupIndex) then
					otherbutton.FAllUp := value;
			end
		end
	end
end;

procedure TBI_basebutton.setgroupindex(value:integer);
begin
	if FGroupIndex = value then
		Exit;
	FGroupIndex := value;
	if (FGroupIndex = 0) and FDown then
	begin
		FDown := False;
		invalidate;
	end;
end;


procedure TBI_basebutton.setflat(value: boolean);
begin
fflat:=value;
if value=false then drawframe:=true else drawframe:=false;
invalidate;
end;

procedure TBI_basebutton.setmark(value: boolean);
begin
if value<>fpopupmark then
begin
fpopupmark:=value;
invalidate;
end;
end;

procedure TBI_basebutton.setglyph(value: tbitmap);
begin
fglyph.assign(value);
if (value<>nil) and (value.height<>0) then
   begin
      fglyph.assign(value);
      transclr:=value.transparentcolor;
      if Value.Width mod Value.Height = 0 then
         fnumglyphs := Value.Width div Value.Height;
      if fnumglyphs>0 then
      gwidth:=fglyph.width div fnumglyphs
      else
      gwidth:=fglyph.width;
   end
else
    begin
    gwidth:=0;
    fnumglyphs:=0;
    end;

invalidate;
end;

procedure TBI_basebutton.Getglyph(const no:byte;var c_glyph:tbitmap);
begin
c_glyph.width:=gwidth;c_glyph.height:=fglyph.height;
case no of
     1: bitblt( c_glyph.canvas.handle,0,0,c_glyph.width,c_glyph.height,
              fglyph.canvas.handle,0,0,srccopy);
     2: if fnumglyphs>1 then
      bitblt( c_glyph.canvas.handle,0,0,c_glyph.width,c_glyph.height,
              fglyph.canvas.handle,gwidth,0,srccopy)
      else
      bitblt( c_glyph.canvas.handle,0,0,c_glyph.width,c_glyph.height,
              fglyph.canvas.handle,0,0,srccopy);
     3: if fnumglyphs>2 then
      bitblt( c_glyph.canvas.handle,0,0,c_glyph.width,c_glyph.height,
              fglyph.canvas.handle,gwidth*2,0,srccopy)
      else
      bitblt( c_glyph.canvas.handle,0,0,c_glyph.width,c_glyph.height,
              fglyph.canvas.handle,0,0,srccopy);
      end;
if flat and (not drawframe) and (not fdown)
 and fgray then mygrayedbmp(c_glyph,fscolor,fecolor);
end;

procedure TBI_basebutton.Notification(AComponent: TComponent; Operation:
TOperation);
begin
if (operation = opRemove) and (AComponent = fpopupmenu) then fpopupmenu := nil;
invalidate;
end;

procedure TBI_basebutton.CMDialogChar(var Message: TCMDialogChar);
var pos:tpoint;
begin
	with Message do
		if IsAccel(CharCode, Caption)and Enabled and Visible then
	begin

                getcursorpos(pos);
                pos:=screentoclient(pos);
		Application.ProcessMessages;
		mousedown(mbleft,[ssleft],pos.x,pos.y);
		Application.ProcessMessages;
		mouseup(mbleft,[ssleft],pos.x,pos.y);
		Application.ProcessMessages;
                click;
		Result := 1;
	end;
end;

procedure TBI_basebutton.CMMouseEnter(var Message: TMessage);
begin
drawframe:=true;
if fflat then repaint;
end;

procedure TBI_basebutton.CMMouseLeave(var Message: TMessage);
begin
if fflat then drawframe:=false else drawframe:=true;
if fflat then repaint;
end;

procedure TBI_basebutton.CMFontChanged(var Message: TMessage);
begin
  invalidate;
end;

procedure TBI_basebutton.CMTextChanged(var Message: TMessage);
begin
  invalidate;
end;

procedure TBI_basebutton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var pos:tpoint;
begin
  inherited MouseDown(Button, Shift, X, Y);
  if (Button = mbLeft) and Enabled then
  begin
      FState := bsDown;
      repaint;
      if fpopupmenu<>nil then
         begin
         application.processmessages;
         if fflat then drawframe:=false else drawframe:=true;
         FState := bsup;
         repaint;
         pos:=ClientToScreen(Point(0, Height));
         fpopupmenu.popup(pos.x,pos.y);
         end;

  end;
end;

procedure TBI_basebutton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  if (Button = mbLeft) and Enabled then
  begin
    fstate:= bsUp;
    repaint;
  end;
end;

procedure TBI_basebutton.setspacing(value: integer);
begin
fspacing:=value;
invalidate;
end;

procedure TBI_basebutton.setbevel(value: integer);
begin
if fbevel<>value then
begin
fbevel:=value;
invalidate;
end;
end;

procedure TBI_basebutton.setecolor(value: tcolor);
begin
fecolor:=value;
invalidate;
end;

procedure TBI_basebutton.internalpaint(var buffer:tbitmap);
var _rect  :trect;
    theglyph:tbitmap;
    gleft,gtop,tleft,ttop,mleft,totalh,adjust2:integer;
begin
tleft:=0; ttop:=0; gleft:=0; gtop:=0; mleft:=0;
{stop compiler warnings}
theglyph:=tbitmap.create;
buffer.canvas.font:=self.font;
if fpopupmark AND (fpopupmenu<>nil) then
   adjust2:=4 else adjust2:=0;
                                            
totalh:=fglyph.height+buffer.canvas.textheight(caption)+2+spacing;

case layout of
     blglyphtop:   begin
                    tleft:=width div 2 - buffer.canvas.textwidth(caption) div 2-adjust2;
                    ttop:=height div 2 - totalh div 2+fglyph.height+spacing;
                    gleft:=width div 2 - gwidth div 2;
                    gtop:=ttop - fglyph.height -spacing;
                    mleft:=tleft+buffer.canvas.textwidth(caption)+2+adjust2 div 2;
                   end;
     blglyphbottom:begin
                    ttop:=height div 2 - totalh div 2;
                    tleft:=width div 2 - buffer.canvas.textwidth(caption) div 2-adjust2;

                    gleft:=width div 2 - gwidth div 2;
                    gtop:=ttop + fglyph.height + spacing;
                    mleft:=tleft+buffer.canvas.textwidth(caption)+2+adjust2 div 2;
                   end;
     blglyphleft:  begin
                    tleft:=width div 2-buffer.canvas.textwidth(caption) div 2+gwidth div 2+spacing;
                    ttop:=height div 2 - buffer.canvas.textheight(caption) div 2;
                    gleft:=tleft-spacing-gwidth;
                    gtop:=height div 2 - fglyph.height div 2;
                    mleft:=tleft+buffer.canvas.textwidth(caption)+2;
                   end;
     blglyphright: begin
                    tleft:=width div 2-buffer.canvas.textwidth(caption) div 2-spacing-gwidth div 2;
                    ttop:=height div 2 - buffer.canvas.textheight(caption) div 2;
                    gleft:=width div 2+buffer.canvas.textwidth(caption) div 2+spacing-gwidth div 2;
                    gtop:=height div 2 - fglyph.height div 2;
                    mleft:=tleft-4;
                   end;
     end;

//drawtext
with buffer.canvas do
     begin
     _rect:=rect(tleft,ttop,width-bevelwidth-1-adjust2,height);
     brush.style:=bsclear;
     if enabled then
     DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_left or dt_noclip)
     else begin
          font.color:=clsilver;
          DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_left or dt_noclip);
          _rect.left:=_rect.left+2;
          _rect.top:=_rect.top+2;
          font.color:=clgray;
          DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_left or dt_noclip);
          end;
     end;

//draw popup-mark
if fpopupmark AND (fpopupmenu<>nil) then
   drawpopupmark(buffer.canvas,mleft,ttop+1);

//draw glyph
if (fglyph<>nil) and (fglyph.height<>0) then
   begin
   if enabled then
   if not (fstate=bsdown) then getglyph(1,theglyph) else getglyph(3,theglyph);
   if not enabled then getglyph(2,theglyph);
   DrawBitmapTransparent(buffer.Canvas,
   gleft, gtop, theglyph, transclr )
   end;

   _rect:=clientrect;
if drawframe AND flat then
   if not((fstate=bsdown) OR down) then
      Frame3D(buffer.Canvas, _rect, lightcolor, shadowcolor, bevelwidth)
   else
      Frame3D(buffer.Canvas, _rect, shadowcolor, lightcolor, bevelwidth);

if (not flat) and (bevelwidth>0) then
                  myDrawButtonFace(buffer.canvas,clientrect,bevelwidth,
                  fdown or (fstate=bsdown) ,shadowcolor, lightcolor);

theglyph.free;
end;

//torry
constructor TBI_torrybutton.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
Screen.Cursors[crHand] := LoadCursor(HInstance, PChar('HAND'));
Cursor := crHand;
ControlStyle := [csSetCaption, csclickevents, csCaptureMouse, csOpaque, csDoubleClicks];
width:=50;
height:=50;
foffset:=3;
fscolor:=clteal;
fecolor:=clblack;
fgroupindex:=0;
fdown:=false;
fallup:=false;
fdowncolor:=fscolor;
fhfont:=tfont.create;
fhfont.assign(self.font);
parentfont:=true;
falign:=tacenter;
drawframe:=false;
end;

procedure TBI_torrybutton.loaded;
begin
inherited loaded;
//for future use...
end;

destructor TBI_torrybutton.destroy;
begin
fHfont.free;
inherited destroy;
end;

procedure TBI_torrybutton.setdown(value: boolean);
var i: Integer;
otherbutton: TBI_torrybutton;
begin
	if FDown = value then
   	Exit;
	if FGroupIndex <> 0 then
	begin
          FDown := value;
          invalidate;
          if FDown = True then
          begin
                  for i := 0 to Parent.ControlCount - 1 do
                  begin
                          if Parent.Controls[i] is TBI_torrybutton then
                          begin
                                  otherbutton := (Parent.Controls[i] as TBI_torrybutton);
                                  if (otherbutton <> Self) and (otherbutton.GroupIndex = GroupIndex)
                                          and (otherbutton.FDown = True) then
                                  begin
                                          otherbutton.FDown := False;
                                          otherbutton.invalidate;
                                  end
                          end
                  end
          end
  end
end;

procedure TBI_torrybutton.setgroupindex(value:integer);
begin
	if FGroupIndex = value then
		Exit;
	FGroupIndex := value;
	if (FGroupIndex = 0) and FDown then
	begin
		FDown := False;
		invalidate;
	end;
end;

procedure TBI_torrybutton.setdowncolor(value:tcolor);
begin
if value = fdowncolor then exit;
fdowncolor:=value;
invalidate;
end;

procedure TBI_torrybutton.setallup(value:boolean);
var i: Integer;
otherbutton: TBI_torrybutton;
begin
	FAllUp := value;
	if FGroupIndex <> 0 then
	begin
		for i := 0 to Parent.ControlCount - 1 do
		begin
			if Parent.Controls[i] is TBI_torrybutton then
			begin
				otherbutton := (Parent.Controls[i] as TBI_torrybutton);
				if (otherbutton <> Self) and (otherbutton.GroupIndex = GroupIndex) then
					otherbutton.FAllUp := value;
			end
		end
	end
end;

procedure TBI_torrybutton.setscolor(value: tcolor);
begin
fscolor:=value;
invalidate;
end;

procedure TBI_torrybutton.setoffset(value: integer);
begin
foffset:=value;
invalidate
end;

procedure TBI_torrybutton.setHfont(value: tfont);
begin
fHfont:=value;
invalidate
end;

procedure TBI_torrybutton.CMMouseEnter(var Message: TMessage);
begin
drawframe:=true;
invalidate
end;

procedure TBI_torrybutton.CMMouseLeave(var Message: TMessage);
begin
drawframe:=false;
invalidate
end;

procedure TBI_torrybutton.CMFontChanged(var Message: TMessage);
begin
  invalidate;
end;

procedure TBI_torrybutton.CMTextChanged(var Message: TMessage);
begin
  invalidate;
end;

procedure TBI_torrybutton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if (Button = mbLeft) and Enabled then
  begin
      FState := bsDown;
      repaint;
  end;
end;

procedure TBI_torrybutton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
    FState := bsUp;
    repaint;
end;


procedure TBI_torrybutton.setalign(value: talignment);
begin
falign:=value;
invalidate;
end;


procedure TBI_torrybutton.setecolor(value: tcolor);
begin
fecolor:=value;
invalidate;
end;

procedure TBI_torrybutton.torrytextout(var buffer:tbitmap);
var adjust:integer;
    _rect  :trect;
begin
if not (drawframe or down) then buffer.canvas.font:=self.font
else buffer.canvas.font:=fHfont;
with buffer.canvas do
     begin
     adjust:=(height-textheight(caption))div 2;

     if drawframe then
     _rect:=rect(0,adjust,width-foffset,height)
     else
     _rect:=rect(0,adjust-foffset,width-foffset,height-foffset);
     brush.style:=bsclear;
     case falign of
          taLeftJustify :
                         DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_left or dt_noclip);
          taRightJustify :
                         DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_right or dt_noclip);
          taCenter:
                         DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_center or dt_noclip);

          end;
     end;
end;

procedure  TBI_torrybutton.paint;
var
    buffer:tbitmap;
begin
buffer:=tbitmap.create;
buffer.width:=width; buffer.height:=height;
buffer.canvas.pen.style:=psclear;
with buffer.canvas do
     begin
     brush.style:=bssolid;
     brush.color:=(parent as twincontrol).brush.color;
     rectangle(0,0,width,height);
     end;
if drawframe or down then
   with buffer.canvas do
   begin
   brush.style:=bssolid;
   brush.color:=fscolor;
   rectangle(foffset,foffset,width,height);
   if down then
      begin
      brush.style:=bssolid;
      brush.color:=fdowncolor;
      rectangle(foffset+3,foffset+3,width-3,height-3);
      end;
   end
else
    with buffer.canvas do
    begin
    brush.style:=bssolid;
    brush.color:=fecolor;
    rectangle(foffset,foffset,width,height);
    brush.color:=fscolor;
    rectangle(0,0,width-foffset,height-foffset);
    end;
torrytextout(buffer);
canvas.draw(1,1,buffer);
buffer.free;
end;

//IE button

constructor TBI_Button.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
style:=bisOpaque;
color:=clbtnface;
end;

procedure TBI_Button.SetOnDraw(Value:TDrawButtonEvent);
begin
fondraw:=value;
invalidate;
end;

procedure TBI_Button.setstyle(value: BI_Buttonstyle);
begin
if value<>fstyle then
begin
fstyle:=value;
if fstyle=bisTransparent then
   ControlStyle := ControlStyle - [csOpaque]
   else
   ControlStyle := ControlStyle + [csOpaque];
invalidate;
end;
end;

procedure TBI_Button.paint;
var buffer:tbitmap;
    face  : boolean;
begin
buffer:=tbitmap.create; buffer.width:=width; buffer.height:=height;
case fstyle of
     bisOpaque:
               with buffer.canvas do begin
               brush.style:=bssolid;
               brush.color:=color;
               fillrect(clientrect);
               internalpaint(buffer);
               canvas.draw(0,0,buffer);
               end;
     bisTransparent:
               with buffer.canvas do begin
               bitblt(buffer.canvas.handle,0,0,width,height,canvas.handle,0,0,srccopy);
               brush.style:=bsclear;
               fillrect(clientrect);
               internalpaint(buffer);
               canvas.draw(0,0,buffer);
               end;
     bisOwnerDraw:
               with buffer.canvas do begin
               bitblt(buffer.canvas.handle,0,0,width,height,canvas.handle,0,0,srccopy);
               if assigned(fondraw) then
                  fondraw(buffer.canvas,clientrect,face);
               if face then internalpaint(buffer);
               canvas.draw(0,0,buffer);
               end;

end;
buffer.free;
end;

//gradientbutton
constructor TBI_gradientbutton.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
fvertical:=false;
end;

procedure TBI_gradientbutton.setvertical(value: boolean);
begin
fvertical:=value;
repaint;
end;


procedure TBI_gradientbutton.Paint;
var x:integer;
    _a,_b,_c:myrgb;
    buffer:tbitmap;
begin

buffer:=tbitmap.create;
buffer.width:=width;buffer.height:=height;

_a.r:=getrvalue(colortorgb(fscolor));
_a.g:=getgvalue(colortorgb(fscolor));
_a.b:=getbvalue(colortorgb(fscolor));


_b.r:=getrvalue(colortorgb(fecolor));
_b.g:=getgvalue(colortorgb(fecolor));
_b.b:=getbvalue(colortorgb(fecolor));

{*
  very very simple dithering is done here
  }
if lowcolor then
      begin
      buffer.canvas.pen.style:=psinsideframe;
      buffer.canvas.pen.width:=2
      end
      else
      begin
      buffer.canvas.pen.style:=pssolid;
      buffer.canvas.pen.width:=1;
      end;


if (not lowcolor) or paint256 then
begin
if not fvertical then
for x:=0 to width do
 with buffer.canvas do
 begin
      if _a.r<_b.r then
            _c.r:=_a.r+round(((_b.r-_a.r) / width)*x)
      else _c.r:=_a.r-round(((_a.r-_b.r) / width)*x);
      if _a.g<_b.g then
            _c.g:=_a.g+round(((_b.g-_a.g) / width)*x)
      else _c.g:=_a.g-round(((_a.g-_b.g) / width)*x);
      if _a.b<_b.b then
            _c.b:=_a.b+round(((_b.b-_a.b) / width)*x)
      else _c.b:=_a.b-round(((_a.b-_b.b) / width)*x);
      pen.color:=rgb(_c.r,_c.g,_c.b);
      moveto(x,0);
      lineto(x,height);
 end
else
for x:=0 to height do
 with buffer.canvas do
 begin
      if _a.r<_b.r then
            _c.r:=_a.r+round(((_b.r-_a.r) / height)*x)
      else _c.r:=_a.r-round(((_a.r-_b.r) / height)*x);
      if _a.g<_b.g then
            _c.g:=_a.g+round(((_b.g-_a.g) / height)*x)
      else _c.g:=_a.g-round(((_a.g-_b.g) / height)*x);
      if _a.b<_b.b then
            _c.b:=_a.b+round(((_b.b-_a.b) / height)*x)
      else _c.b:=_a.b-round(((_a.b-_b.b) / height)*x);
      pen.color:=rgb(_c.r,_c.g,_c.b);
      moveto(0,x);
      lineto(width,x);
 end;
end
else
begin
buffer.canvas.brush.color:=clbtnface;
buffer.canvas.fillrect(clientrect);
end;
internalpaint(buffer);
bitblt(canvas.handle,canvas.cliprect.left,canvas.cliprect.top,
canvas.cliprect.right,canvas.cliprect.bottom,buffer.canvas.handle,
canvas.cliprect.left,canvas.cliprect.top,srccopy);
{only paint the part that needs to be repainted!}
buffer.free;
end;

/////Plasma

constructor TBI_plasmabutton.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
randomize;
plasmabuffer:=tbitmap.create;
createplasma;
end;

destructor TBI_plasmabutton.destroy;
begin
plasmabuffer.free;
inherited destroy;
end;

procedure TBI_plasmabutton.recalc;
begin
createplasma;
invalidate;
end;

procedure getplasma(var buffer:tbitmap;const c1,c2:tcolor);
var imdata : ARRAY [ 0 .. 150,0 .. 150] OF BYTE;
    x,y:integer;
    colors:array[0..255] of myrgb;
            procedure calccolors;
             var x:integer;
                 _a,_b,_c:myrgb;
             begin
             _a.r:=getrvalue(colortorgb(c1));
             _a.g:=getgvalue(colortorgb(c1));
             _a.b:=getbvalue(colortorgb(c1));
             _b.r:=getrvalue(colortorgb(c2));
             _b.g:=getgvalue(colortorgb(c2));
             _b.b:=getbvalue(colortorgb(c2));
             for x:=0 to 236 do
                 begin
                       if _a.r<_b.r then
                       _c.r:=_a.r+round(((_b.r-_a.r) / 236)*x)
                       else _c.r:=_a.r-round(((_a.r-_b.r) / 236)*x);
                       if _a.g<_b.g then
                       _c.g:=_a.g+round(((_b.g-_a.g) / 236)*x)
                       else _c.g:=_a.g-round(((_a.g-_b.g) / 236)*x);
                       if _a.b<_b.b then
                       _c.b:=_a.b+round(((_b.b-_a.b) / 236)*x)
                       else _c.b:=_a.b-round(((_a.b-_b.b) / 236)*x);
                       colors[x]:=_c;
                 end;
             end;

            function create256bitmap(x,y:integer;colors:array of
             myrgb):hbitmap;
             VAR
               hdc : THandle;
               hbmImage : HBITMAP;
               bmDef : RECORD
                         bmHdr : TBitmapInfo;
                         bmColors : ARRAY [ 0 .. 255 ] OF TRGBQuad;
                       END;
               z:byte;
               address:pointer;
             BEGIN
               for z:=0 to 255 do
               begin
               bmDef.bmColors[z].rgbRed := colors[z].r;
               bmDef.bmColors[z].rgbGreen := colors[z].g;
               bmDef.bmColors[z].rgbBlue := colors[z].b;
               bmDef.bmColors[z].rgbReserved := 0;
               end;
               {IF hbmImage <> 0 THEN
                 DeleteObject( hbmImage ); }
               WITH bmDef.bmHdr.bmiHeader DO BEGIN
                   biSize := SIZEOF( TBITMAPINFOHEADER);
                   biWidth :=x;
                   biHeight := y;
                   biPlanes := 1;
                   biBitCount := 8;
                   biCompression := BI_RGB;
                   biSizeImage := 0;
                   biXPelsPerMeter := 0;
                   biYPelsPerMeter := 0;
                   biClrUsed := 0;
                   biClrImportant := 0;
                 END;
               //i hope this is d3 - compatible.... :/
               address:=addr(imdata);
               hdc := GetDC(0);
               hbmImage := CreateDIBitmap( hdc, bmDef.bmHdr.bmiHeader, CBM_INIT,
                                           address, bmDef.bmHdr, DIB_RGB_COLORS );
               ReleaseDC( 0, hdc );
               result:=hbmimage;
             END;

            procedure subDivide(x1,y1,x2,y2: integer);
              procedure adjust(xa,ya,x,y,xb,yb: integer);
               var
                 d: integer;
                 v: double;
             begin
               if imdata[x,y]<>0 then exit;
               d:=Abs(xa-xb)+Abs(ya-yb);
               v:=(imdata[xa,ya]+imdata[xb,yb])/2+(random-0.5)*d*8;
               if v<1 then v:=1;
               if v>=236 then v:=236;
               imdata[x,y]:=Trunc(v);
             end;

         var
            x,y: integer;
            v: double;
         begin
          if (x2-x1<2) and (y2-y1<2) then exit;
          x:=(x1+x2) div 2;
          y:=(y1+y2) div 2;
          adjust(x1,y1,x,y1,x2,y1);
          adjust(x2,y1,x2,y,x2,y2);
          adjust(x1,y2,x,y2,x2,y2);
          adjust(x1,y1,x1,y,x1,y2);
          if imdata[x,y]=0 then
            begin
              v:=(imdata[x1,y1]+imdata[x2,y1]+imdata[x2,y2]+imdata[x1,y2])/4;
              imdata[x,y]:=Trunc(v);
            end;
          subDivide(x1,y1,x,y);
          subDivide(x,y1,x2,y);
          subDivide(x,y,x2,y2);
          subDivide(x1,y,x,y2);
        end;
begin
calccolors;
for y:=0 to 150 do
    for x:=0 to 150 do
    imdata[x,y]:=0;
imdata[0,150]:=random(236);
imdata[150,150]:=random(236);
imdata[150,150]:=random(236);
imdata[0,0]:=random(236);
subDivide(0,0,150,150);
buffer.handle:=create256bitmap(150,150,colors);
buffer.dormant;
end;

procedure TBI_plasmabutton.createplasma;
begin
randomize;
plasmabuffer.width:=150;
plasmabuffer.height:=150;
getplasma(plasmabuffer,fscolor,fecolor);
end;

procedure TBI_plasmabutton.setscolor(value: tcolor);
begin
if value<>fscolor then
begin
fscolor:=value;
createplasma;
invalidate;
end;
end;

procedure TBI_plasmabutton.setecolor(value: tcolor);
begin
if value<>fecolor then
begin
fecolor:=value;
createplasma;
repaint;
end;
end;

procedure TBI_plasmabutton.Paint;
var
    buffer:tbitmap;
begin
buffer:=tbitmap.create;
buffer.width:=width;buffer.height:=height;

if (not lowcolor) or paint256 then
begin
   if (width<150) AND (height<150) then
       buffer.canvas.draw(0,0,plasmabuffer)
   else
       buffer.canvas.stretchdraw(clientrect,plasmabuffer);
end
else
begin
buffer.canvas.brush.color:=clbtnface;
buffer.canvas.fillrect(clientrect);
end;

internalpaint(buffer);
bitblt(canvas.handle,canvas.cliprect.left,canvas.cliprect.top,
canvas.cliprect.right,canvas.cliprect.bottom,buffer.canvas.handle,
canvas.cliprect.left,canvas.cliprect.top,srccopy);
buffer.free;
end;

//image
constructor TBI_imagebutton.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
fupimage:=tbitmap.create;
fdownimage:=tbitmap.create;
fmouseoverimage:=tbitmap.create;
fstretch:=true;
ftrans:=true;
ftransclr:=clwhite;
drawMOI:=false;
end;

destructor TBI_imagebutton.destroy;
begin
fupimage.free;
fdownimage.free;
fmouseoverimage.free;
inherited destroy;
end;

procedure TBI_imagebutton.setstretch(value: boolean);
begin
if value<>fstretch then
   begin
   fstretch:=value;
   invalidate;
   end;
end;

procedure TBI_imagebutton.settransclr(value:tcolor);
begin
if value<>ftransclr then
begin
ftransclr:=value;
invalidate;
end;
end;

procedure TBI_imagebutton.settrans(value: boolean);
begin
if value<>ftrans then
   begin
   ftrans:=value;
   if ftrans then controlstyle:=controlstyle - [csopaque];
   invalidate;
   end;
end;

procedure TBI_imagebutton.checkothers;
begin
if fupimage.width>0 then
   begin
        if fdownimage.width<1 then fdownimage.assign(fupimage);
        if fmouseoverimage.width<1 then fmouseoverimage.assign(fupimage);
   end;
end;

procedure TBI_imagebutton.setupimage(value: tbitmap);
begin
fupimage.assign(value);
checkothers;
invalidate;
end;

procedure TBI_imagebutton.setDownimage(value: tbitmap);
begin
fDownimage.assign(value);
checkothers;
invalidate;
end;

procedure TBI_imagebutton.setmouseoverimage(value: tbitmap);
begin
fmouseoverimage.assign(value);
if drawmoi then invalidate;
end;

procedure TBI_imagebutton.CMMouseEnter(var Message: TMessage);
begin
drawframe:=true;
if fflat then paint;
if assigned(mouseoverimage) then drawMOI:=true else drawMOI:=false;
repaint;
end;

procedure TBI_imagebutton.CMMouseLeave(var Message: TMessage);
begin
if fflat then drawframe:=false else drawframe:=true;
if fflat then paint;
drawMOI:=false;
repaint;
end;

procedure  TBI_imagebutton.paint;
var
    buffer:tbitmap;
    _rect:trect;
begin
if (downimage.width<1) or (mouseoverimage.width<1) then checkothers;
buffer:=tbitmap.create;
buffer.width:=width;buffer.height:=height;
_rect:=clientrect;
if not ftrans then
begin
buffer.canvas.brush.color:=(parent as twincontrol).brush.color;
buffer.canvas.fillrect(_rect);
end
else
bitblt(buffer.canvas.handle,0,0,width,height,canvas.handle,0,0,srccopy);

if (not lowcolor) or paint256 or (upimage.width<1) then
begin
 if not ftrans then
 begin
   if fstate=bsdown  then
      begin
         if not fstretch then buffer.canvas.draw(0,0,downimage)
         else buffer.canvas.stretchdraw(_rect,downimage);
      end
   else
   if not fstretch then
   begin
      if drawMOI then buffer.canvas.draw(0,0,mouseoverimage)
   else if not drawmoi then buffer.canvas.draw(0,0,upimage);
   end
   else
   begin
      if drawMOI then buffer.canvas.stretchdraw(_rect,mouseoverimage)
   else if not drawmoi then buffer.canvas.stretchdraw(_rect,upimage);
   end;
 end
 else
 begin
   if fstate=bsdown  then
      begin
         if not fstretch then DrawBitmapTransparent(buffer.Canvas, 0, 0, downimage, ftransclr )
         else StretchBitmapRectTransparent(buffer.canvas,0,0,width,height,_rect,downimage,ftransclr);
      end
   else
   if not fstretch then
   begin
      if drawMOI then DrawBitmapTransparent(buffer.Canvas, 0, 0, mouseoverimage, ftransclr )
   else if not drawmoi then DrawBitmapTransparent(buffer.Canvas, 0, 0, upimage, ftransclr )
   end
   else
   begin
      if drawMOI then StretchBitmapRectTransparent(buffer.canvas,0,0,width,height,_rect,mouseoverimage,ftransclr)
   else if not drawmoi then StretchBitmapRectTransparent(buffer.canvas,0,0,width,height,_rect,upimage,ftransclr);
   end;
 end;
end
else
begin
buffer.canvas.brush.color:=clbtnface;
buffer.canvas.fillrect(clientrect);
end;
internalpaint(buffer);
bitblt(canvas.handle,canvas.cliprect.left,canvas.cliprect.top,
canvas.cliprect.right,canvas.cliprect.bottom,buffer.canvas.handle,
canvas.cliprect.left,canvas.cliprect.top,srccopy);
buffer.free;
end;

end.
