unit bi_tools;

interface

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,Registry,shellapi,menus, bi_procs,bi_timer;

type

  TClrConverter = class (tcomponent)
    private
    fR,fG,fB,fC,fM,fY,Fk,fS,fl,fh  : byte;
    fcolor               : tcolor;
    procedure setr (value:byte);
    procedure setg (value:byte);
    procedure setb (value:byte);
    procedure setc (value:byte);
    procedure setm (value:byte);
    procedure sety (value:byte);
    procedure setk (value:byte);
    procedure seth (value:byte);
    procedure sets (value:byte);
    procedure setl (value:byte);
    procedure setcolor (value:tcolor);
    Published
    property R:byte read fR write setR;
    property G:byte read fg write setg;
    property B:byte read fb write setb;
    property C:byte read fc write setc;
    property M:byte read fm write setm;
    property Y:byte read fy write sety;
    property K:byte read fk write setk;
    property H:byte read fh write seth;
    property S:byte read fs write sets;
    property L:byte read fL write setL;
    property Color:tcolor read fcolor write setcolor;
    property Name;
    end;
                      
    THotSpotArea=(hsaClient, hsaScreen);
    TInHotSpot=procedure(Mouseposition:TPoint) of object;


  TBI_Hotspot = class(tcomponent)
    private
    timer : tbi_timer;
    f_left : longint;
    f_top  : longint;
    fright: longint;
    fbottom:longint;
    finterval:integer;
    farea :THotSpotArea;
    factive:boolean;
    fpriority:tthreadpriority;
    fOnIn:TInHotSpot;
    fmovedIn:TInHotSpot;
    fmovedOut:TInHotSpot;

    lastpos:tpoint;
    procedure checkpos(sender:tobject);
    procedure setactive(value:boolean);
    procedure setinterval(value:integer);
    procedure setpriority(value:Tthreadpriority);
    public
    constructor create(aowner:TComponent);override;
    destructor destroy; override;
    published
    Property RectLeft:longint read f_left write f_left;
    Property RectTop:longint read f_top write f_top;
    Property RectRight:longint read fright write fright;
    Property RectBottom:longint read fbottom write fbottom;
    Property Area:THotSpotArea read farea write farea;
    Property Active:boolean read factive write setactive;
    Property Interval:integer read finterval write setinterval;
    Property ThreadPriority:Tthreadpriority read fpriority write setpriority;
    Property OnInHotspot:TinHotspot read fonin write fonin;
    Property OnEnter:TinHotspot read fmovedin write fmovedin;
    Property OnLeave:TinHotspot read fmovedout write fmovedout;
    end;

    TInstantHint = class(Tcomponent)
    private
    f_left,
    f_top,
    fright,
    fbottom      : Integer;
    fcaption     : string;
    fcolor       : tcolor;
    fpause       : integer;
    fautosize    : boolean;
    public
    constructor create(AOwner:tcomponent);override;
    procedure Execute;
    published
    property RectLeft   :integer read f_left write f_left;
    property RectTop    :integer read f_top write f_top;
    property RectRight  :integer read fright write fright;
    property RectBottom :integer read fbottom write fbottom;
    property AutoSize   :boolean read fautosize write fautosize;
    property HidePause:integer read fpause write fpause;
    property Color  :Tcolor read fcolor write fcolor;
    property Caption:string read fcaption write fcaption;
    end;

implementation


constructor TBI_Hotspot.create(aowner:TComponent);
begin
inherited create(aowner);

factive:=false;
finterval:=55;
f_left:=0;
fright:=100;
f_top:=0;
fbottom:=100;
lastpos:=point(-1,-1);
fpriority:=tpidle;
farea:=hsaScreen;
timer:=tbi_timer.create(self);
timer.interval:=55;
timer.threadpriority:=tpidle;
timer.enabled:=false;
timer.ontimer:=checkpos;
end;

destructor TBI_Hotspot.destroy;
begin
timer.enabled:=false;
timer.free;
inherited destroy;
end;

procedure TBI_Hotspot.setactive(value:boolean);
begin
if value<>factive then
   begin
   factive:=value;
   timer.enabled:=value;
   end;
end;

procedure TBI_Hotspot.setinterval(value:integer);
begin
if value<>finterval then
   begin
   timer.enabled:=false;
   timer.interval:=value;
   finterval:=value;
   timer.enabled:=factive;
   end;
end;

procedure TBI_Hotspot.setpriority(value:Tthreadpriority);
begin
if value<>fpriority then
   begin
   timer.enabled:=false;
   timer.threadpriority:=value;
   fpriority:=value;
   timer.enabled:=active;
   end;
end;

procedure TBI_Hotspot.checkpos(sender:tobject);
          function inside(__pos:tpoint):boolean;
          begin
          result:=
          (__pos.x>f_left) and (__pos.x<fright) and (__pos.y>f_top) and (__pos.y<fbottom)
          end;
var _pos:tpoint;
begin

if not (csDesigning in componentstate) and factive then
   begin
   getcursorpos(_pos);
   if farea=hsaClient then if owner is twincontrol then
      _pos:=(owner as twincontrol).screentoclient(_pos);

   if inside(_pos) then
          begin
          if assigned(fonin) then
             fonin(_pos);
          if assigned(fmovedin) and not inside(lastpos) then
          fmovedin(_pos);
          end
       else
       if assigned(fmovedout) and inside(lastpos) then fmovedout(_pos);
    getcursorpos(lastpos);
    if farea=hsaClient then if owner is twincontrol then
      lastpos:=(owner as twincontrol).screentoclient(lastpos);
   end;
end;

//<..............................................................................

procedure tclrconverter.setr (value:byte);
begin
fr:=value;
rgbtocmyk(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setg (value:byte);
begin
fg:=value;
rgbtocmyk(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setb (value:byte);
begin
fb:=value;
rgbtocmyk(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setc (value:byte);
begin
fc:=value;
cmyktorgb(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setm (value:byte);
begin
fm:=value;
cmyktorgb(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.sety (value:byte);
begin
fy:=value;
cmyktorgb(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setk (value:byte);
begin
fk:=value;
cmyktorgb(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.seth (value:byte);
begin
fh:=value;
HSLRangeToRGB(fh,fs,fl,fr,fg,fb);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.sets (value:byte);
begin
fs:=value;
HSLRangeToRGB(fh,fs,fl,fr,fg,fb);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setl (value:byte);
begin
fs:=value;
HSLRangeToRGB(fh,fs,fl,fr,fg,fb);
fcolor:=rgb(fr,fg,fb);
end;

procedure tclrconverter.setcolor (value:tcolor);
begin
fcolor:=value;
fr:=getrvalue(value);
fg:=getgvalue(value);
fb:=getbvalue(value);
rgbtocmyk(fr,fg,fb,fc,fm,fy,fk);
RGBtoHSLRange(fr,fg,fb,fh,fs,fl);
end;

//<<-----------------------------------------------

Constructor TInstantHint.Create(aowner:tcomponent);
begin
inherited create(aowner);
f_left:=0; f_top:=0; fright:=100; fbottom:=100;
fautosize:=true;
fcolor:=application.hintcolor;
fpause:=application.hinthidepause;
fcaption:='TInstantHint';
end;

procedure TInstantHint.execute;
          procedure waitext(ms:integer);
          var tmp:integer;
              _pos1,_pos2:tpoint;
          begin
          tmp:=gettickcount;
          getcursorpos(_pos1);
          while tmp+ms>gettickcount do
                begin
                getcursorpos(_pos2);
                if (_pos1.x<>_pos2.x) or (_pos1.y<>_pos2.y) then break;
                application.processmessages;
                end;
          end;

var thehint : THintWindow;
    _rect : TRect;
    adjust:integer;
begin
_rect:=rect(f_left,f_top,fright,fbottom);
thehint := THintWindow.Create( self );
with thehint do
     begin
     color:=fcolor;
     if fautosize then
     begin
        adjust:=thehint.canvas.textwidth(fcaption);
        _rect.right:=_rect.left+adjust+6;
        adjust:=thehint.canvas.textheight(fcaption);
        _rect.bottom:=_rect.top+adjust+2;
     end;
     activatehint(_rect,fcaption);
     waitext(fpause);
     releasehandle;
     free;
     end;
end;

end.
